diff --git a/web/regression/javascript/SchemaView/SchemaView.spec.js b/web/regression/javascript/SchemaView/SchemaView.spec.js
index 848965980..d4b743026 100644
--- a/web/regression/javascript/SchemaView/SchemaView.spec.js
+++ b/web/regression/javascript/SchemaView/SchemaView.spec.js
@@ -112,7 +112,9 @@ describe('SchemaView', ()=>{
         ctrl.find('MappedCellControl[id="field5"]').at(1).find('input').simulate('change', {target: {value: 'rval52'}});
       };
     beforeEach(()=>{
-      ctrlMount();
+      ctrlMount({
+        getInitData: ()=>Promise.resolve({}),
+      });
     });
 
     it('init', (done)=>{
@@ -140,20 +142,26 @@ describe('SchemaView', ()=>{
     });
 
     it('close error on click', (done)=>{
-      ctrl.find('FormFooterMessage').find('button').simulate('click');
       setTimeout(()=>{
         ctrl.update();
-        expect(ctrl.find('FormFooterMessage').prop('message')).toBe('');
-        done();
+        ctrl.find('FormFooterMessage').find('button').simulate('click');
+        setTimeout(()=>{
+          ctrl.update();
+          expect(ctrl.find('FormFooterMessage').prop('message')).toBe('');
+          done();
+        }, 0);
       }, 0);
     });
 
     it('valid form data', (done)=>{
-      simulateValidData();
       setTimeout(()=>{
         ctrl.update();
-        expect(ctrl.find('FormFooterMessage').prop('message')).toBeFalsy();
-        done();
+        simulateValidData();
+        setTimeout(()=>{
+          ctrl.update();
+          expect(ctrl.find('FormFooterMessage').prop('message')).toBeFalsy();
+          done();
+        }, 0);
       }, 0);
     });
 
@@ -165,50 +173,62 @@ describe('SchemaView', ()=>{
       };
 
       it('add row', (done)=>{
-        ctrl.find('DataGridView').find('PgIconButton[data-test="add-row"]').find('button').simulate('click');
         setTimeout(()=>{
-          ctrlUpdate(done);
+          ctrl.update();
+          ctrl.find('DataGridView').find('PgIconButton[data-test="add-row"]').find('button').simulate('click');
+          setTimeout(()=>{
+            ctrlUpdate(done);
+          }, 0);
         }, 0);
       });
 
       it('remove row', (done)=>{
-        simulateValidData();
-
-        /* Press OK */
-        let confirmSpy = spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn)=>{
-          yesFn();
-        });
-        ctrl.find('DataGridView').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
-        expect(confirmSpy.calls.argsFor(0)[2]).toBe('Custom delete title');
-        expect(confirmSpy.calls.argsFor(0)[3]).toBe('Custom delete message');
-
-        /* Press Cancel */
-        spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn, cancelFn)=>{
-          cancelFn();
-        });
-        ctrl.find('DataGridView').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
         setTimeout(()=>{
-          ctrlUpdate(done);
+          ctrl.update();
+          simulateValidData();
+
+          /* Press OK */
+          let confirmSpy = spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn)=>{
+            yesFn();
+          });
+          ctrl.find('DataGridView').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
+          expect(confirmSpy.calls.argsFor(0)[2]).toBe('Custom delete title');
+          expect(confirmSpy.calls.argsFor(0)[3]).toBe('Custom delete message');
+
+          /* Press Cancel */
+          spyOn(legacyConnector, 'confirmDeleteRow').and.callFake((yesFn, cancelFn)=>{
+            cancelFn();
+          });
+          ctrl.find('DataGridView').find('PgIconButton[data-test="delete-row"]').at(0).find('button').simulate('click');
+          setTimeout(()=>{
+            ctrlUpdate(done);
+          }, 0);
         }, 0);
       });
 
       it('expand row', (done)=>{
-        simulateValidData();
-        ctrl.find('DataGridView').find('PgIconButton[data-test="expand-row"]').at(0).find('button').simulate('click');
         setTimeout(()=>{
           ctrl.update();
-          expect(ctrl.find('DataGridView').find('FormView').length).toBe(1);
-          done();
+          simulateValidData();
+          ctrl.find('DataGridView').find('PgIconButton[data-test="expand-row"]').at(0).find('button').simulate('click');
+          setTimeout(()=>{
+            ctrl.update();
+            expect(ctrl.find('DataGridView').find('FormView').length).toBe(1);
+            done();
+          }, 0);
         }, 0);
       });
 
       it('unique col test', (done)=>{
-        simulateValidData();
-        ctrl.find('MappedCellControl[id="field5"]').at(1).find('input').simulate('change', {target: {value: 'rval51'}});
         setTimeout(()=>{
           ctrl.update();
-          expect(ctrl.find('FormFooterMessage').prop('message')).toBe('Field5 in FieldColl must be unique.');
-          done();
+          simulateValidData();
+          ctrl.find('MappedCellControl[id="field5"]').at(1).find('input').simulate('change', {target: {value: 'rval51'}});
+          setTimeout(()=>{
+            ctrl.update();
+            expect(ctrl.find('FormFooterMessage').prop('message')).toBe('Field5 in FieldColl must be unique.');
+            done();
+          }, 0);
         }, 0);
       });
     });
@@ -224,44 +244,53 @@ describe('SchemaView', ()=>{
       });
 
       it('data invalid', (done)=>{
-        ctrl.find('MappedFormControl[id="field2"]').find('input').simulate('change', numberChangeEvent('2'));
-        ctrl.find('ForwardRef(Tab)[label="SQL"]').find('button').simulate('click');
         setTimeout(()=>{
           ctrl.update();
-          expect(ctrl.find('CodeMirror').prop('value')).toBe('-- Definition incomplete.');
-          done();
+          ctrl.find('MappedFormControl[id="field2"]').find('input').simulate('change', numberChangeEvent('2'));
+          ctrl.find('ForwardRef(Tab)[label="SQL"]').find('button').simulate('click');
+          setTimeout(()=>{
+            ctrl.update();
+            expect(ctrl.find('CodeMirror').prop('value')).toBe('-- Definition incomplete.');
+            done();
+          }, 0);
         }, 0);
       });
 
       it('valid data', (done)=>{
-        simulateValidData();
-        ctrl.find('ForwardRef(Tab)[label="SQL"]').find('button').simulate('click');
         setTimeout(()=>{
           ctrl.update();
-          expect(ctrl.find('CodeMirror').prop('value')).toBe('select 1;');
-          done();
+          simulateValidData();
+          ctrl.find('ForwardRef(Tab)[label="SQL"]').find('button').simulate('click');
+          setTimeout(()=>{
+            ctrl.update();
+            expect(ctrl.find('CodeMirror').prop('value')).toBe('select 1;');
+            done();
+          }, 0);
         }, 0);
       });
     });
 
     it('onSave click', (done)=>{
-      simulateValidData();
-      onSave.calls.reset();
-      ctrl.find('PrimaryButton[data-test="Save"]').simulate('click');
       setTimeout(()=>{
-        expect(onSave.calls.argsFor(0)[0]).toBe(true);
-        expect(onSave.calls.argsFor(0)[1]).toEqual({
-          id: undefined,
-          field1: 'val1',
-          field2: '2',
-          field5: 'val5',
-          fieldcoll: [
-            {field3: null, field4: null, field5:  'rval51'},
-            {field3: null, field4: null, field5:  'rval52'},
-          ]
-        });
-        expect(Notify.alert).toHaveBeenCalledWith('Warning', 'some inform text');
-        done();
+        ctrl.update();
+        simulateValidData();
+        onSave.calls.reset();
+        ctrl.find('PrimaryButton[data-test="Save"]').simulate('click');
+        setTimeout(()=>{
+          expect(onSave.calls.argsFor(0)[0]).toBe(true);
+          expect(onSave.calls.argsFor(0)[1]).toEqual({
+            id: undefined,
+            field1: 'val1',
+            field2: '2',
+            field5: 'val5',
+            fieldcoll: [
+              {field3: null, field4: null, field5:  'rval51'},
+              {field3: null, field4: null, field5:  'rval52'},
+            ]
+          });
+          expect(Notify.alert).toHaveBeenCalledWith('Warning', 'some inform text');
+          done();
+        }, 0);
       }, 0);
     });
 
@@ -275,28 +304,34 @@ describe('SchemaView', ()=>{
 
     describe('onReset', ()=>{
       it('with confirm check and yes click', (done)=>{
-        simulateValidData();
-        onDataChange.calls.reset();
-        let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
-        ctrl.find('DefaultButton[data-test="Reset"]').simulate('click');
-        /* Press OK */
-        confirmSpy.calls.argsFor(0)[2]();
         setTimeout(()=>{
-          onRestAction(done);
+          ctrl.update();
+          simulateValidData();
+          onDataChange.calls.reset();
+          let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
+          ctrl.find('DefaultButton[data-test="Reset"]').simulate('click');
+          /* Press OK */
+          confirmSpy.calls.argsFor(0)[2]();
+          setTimeout(()=>{
+            onRestAction(done);
+          }, 0);
         }, 0);
       });
 
       it('with confirm check and cancel click', (done)=>{
-        simulateValidData();
-        let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
-        ctrl.find('DefaultButton[data-test="Reset"]').simulate('click');
-        /* Press cancel */
-        confirmSpy.calls.argsFor(0)[3]();
         setTimeout(()=>{
           ctrl.update();
-          expect(ctrl.find('DefaultButton[data-test="Reset"]').prop('disabled')).toBeFalse();
-          expect(ctrl.find('PrimaryButton[data-test="Save"]').prop('disabled')).toBeFalse();
-          done();
+          simulateValidData();
+          let confirmSpy = spyOn(Notify, 'confirm').and.callThrough();
+          ctrl.find('DefaultButton[data-test="Reset"]').simulate('click');
+          /* Press cancel */
+          confirmSpy.calls.argsFor(0)[3]();
+          setTimeout(()=>{
+            ctrl.update();
+            expect(ctrl.find('DefaultButton[data-test="Reset"]').prop('disabled')).toBeFalse();
+            expect(ctrl.find('PrimaryButton[data-test="Save"]').prop('disabled')).toBeFalse();
+            done();
+          }, 0);
         }, 0);
       });
 
diff --git a/web/regression/javascript/components/CodeMirror.spec.js b/web/regression/javascript/components/CodeMirror.spec.js
index 758c6be6f..7e8d8f248 100644
--- a/web/regression/javascript/components/CodeMirror.spec.js
+++ b/web/regression/javascript/components/CodeMirror.spec.js
@@ -11,9 +11,11 @@ import jasmineEnzyme from 'jasmine-enzyme';
 import React from 'react';
 import '../helper/enzyme.helper';
 import {default as OrigCodeMirror} from 'bundled_codemirror';
+import { withTheme } from '../fake_theme';
 
 import CodeMirror from 'sources/components/CodeMirror';
 import { mount } from 'enzyme';
+import { FindDialog } from '../../../pgadmin/static/js/components/CodeMirror';
 
 describe('CodeMirror', ()=>{
   let cmInstance, options={
@@ -27,13 +29,36 @@ describe('CodeMirror', ()=>{
       'setOption': ()=>{/*This is intentional (SonarQube)*/},
       'removeKeyMap': ()=>{/*This is intentional (SonarQube)*/},
       'addKeyMap': ()=>{/*This is intentional (SonarQube)*/},
+      'getSearchCursor': {
+        _from: 3,
+        _to: 14,
+        find: function(_rev) {
+          if(_rev){
+            this._from = 1;
+            this._to = 10;
+          } else {
+            this._from = 3;
+            this._to = 14;
+          }
+          return true;
+        },
+        from: function() {return this._from;},
+        to: function() {return this._to;},
+        replace: jasmine.createSpy('replace'),
+      },
+      'getCursor': ()=>{/*This is intentional (SonarQube)*/},
+      'removeOverlay': ()=>{/*This is intentional (SonarQube)*/},
+      'addOverlay': ()=>{/*This is intentional (SonarQube)*/},
+      'setSelection': ()=>{/*This is intentional (SonarQube)*/},
+      'scrollIntoView': ()=>{/*This is intentional (SonarQube)*/},
       'getWrapperElement': document.createElement('div'),
     });
   beforeEach(()=>{
     jasmineEnzyme();
     spyOn(OrigCodeMirror, 'fromTextArea').and.returnValue(cmObj);
+    const ThemedCM = withTheme(CodeMirror);
     cmInstance = mount(
-      <CodeMirror
+      <ThemedCM
         value={'Init text'}
         options={options}
         className="testClass"
@@ -42,12 +67,142 @@ describe('CodeMirror', ()=>{
 
   it('init', ()=>{
     /* textarea ref passed to fromTextArea */
-    expect(OrigCodeMirror.fromTextArea).toHaveBeenCalledWith(cmInstance.find('textarea').getDOMNode(), options);
+    expect(OrigCodeMirror.fromTextArea).toHaveBeenCalledWith(cmInstance.find('textarea').getDOMNode(), jasmine.objectContaining(options));
     expect(cmObj.setValue).toHaveBeenCalledWith('Init text');
   });
 
   it('change value', ()=>{
     cmInstance.setProps({value: 'the new text'});
     expect(cmObj.setValue).toHaveBeenCalledWith('the new text');
+
+    cmInstance.setProps({value: null});
+    expect(cmObj.setValue).toHaveBeenCalledWith('');
+  });
+
+
+  describe('FindDialog', ()=>{
+    let ctrl;
+    const onClose = jasmine.createSpy('onClose');
+    const ThemedFindDialog = withTheme(FindDialog);
+    const ctrlMount = (props, callback)=>{
+      ctrl?.unmount();
+      ctrl = mount(
+        <ThemedFindDialog
+          editor={cmObj}
+          show={true}
+          onClose={onClose}
+          {...props}
+        />
+      );
+      setTimeout(()=>{
+        ctrl.update();
+        callback();
+      }, 0);
+    };
+
+    it('init', (done)=>{
+      ctrlMount({}, ()=>{
+        cmObj.removeOverlay.calls.reset();
+        cmObj.addOverlay.calls.reset();
+        ctrl.find('InputText').find('input').simulate('change', {
+          target: {value: '\n\r\t\A'},
+        });
+        setTimeout(()=>{
+          expect(cmObj.removeOverlay).toHaveBeenCalled();
+          expect(cmObj.addOverlay).toHaveBeenCalled();
+          expect(cmObj.setSelection).toHaveBeenCalledWith(3, 14);
+          expect(cmObj.scrollIntoView).toHaveBeenCalled();
+          done();
+        }, 0);
+      });
+    });
+
+    it('reverse forward', (done)=>{
+      ctrlMount({}, ()=>{
+        ctrl.find('InputText').find('input').simulate('change', {
+          target: {value: 'A'},
+        });
+        cmObj.setSelection.calls.reset();
+        cmObj.addOverlay.calls.reset();
+        ctrl.find('InputText').find('input').simulate('keypress', {
+          key: 'Enter', shiftKey: true,
+        });
+        ctrl.find('InputText').find('input').simulate('keypress', {
+          key: 'Enter', shiftKey: false,
+        });
+        setTimeout(()=>{
+          expect(cmObj.setSelection).toHaveBeenCalledWith(1, 10);
+          expect(cmObj.setSelection).toHaveBeenCalledWith(3, 14);
+          done();
+        }, 0);
+      });
+    });
+
+
+    it('escape', (done)=>{
+      ctrlMount({}, ()=>{
+        cmObj.removeOverlay.calls.reset();
+        ctrl.find('InputText').find('input').simulate('keydown', {
+          key: 'Escape',
+        });
+        setTimeout(()=>{
+          expect(cmObj.removeOverlay).toHaveBeenCalled();
+          done();
+        }, 0);
+      });
+    });
+
+    it('toggle match case', (done)=>{
+      ctrlMount({}, ()=>{
+        expect(ctrl.find('PgIconButton[data-test="case"]').props()).toEqual(jasmine.objectContaining({
+          color: 'default'
+        }));
+        ctrl.find('PgIconButton[data-test="case"]').find('button').simulate('click');
+        setTimeout(()=>{
+          expect(ctrl.find('PgIconButton[data-test="case"]').props()).toEqual(jasmine.objectContaining({
+            color: 'primary'
+          }));
+          done();
+        }, 0);
+      });
+    });
+
+    it('toggle regex', (done)=>{
+      ctrlMount({}, ()=>{
+        ctrl.find('InputText').find('input').simulate('change', {
+          target: {value: 'A'},
+        });
+        expect(ctrl.find('PgIconButton[data-test="regex"]').props()).toEqual(jasmine.objectContaining({
+          color: 'default'
+        }));
+        ctrl.find('PgIconButton[data-test="regex"]').find('button').simulate('click');
+        setTimeout(()=>{
+          expect(ctrl.find('PgIconButton[data-test="regex"]').props()).toEqual(jasmine.objectContaining({
+            color: 'primary'
+          }));
+          done();
+        }, 0);
+      });
+    });
+
+    it('replace', (done)=>{
+      ctrlMount({replace: true}, ()=>{
+        cmObj.getSearchCursor().replace.calls.reset();
+        ctrl.find('InputText').at(0).find('input').simulate('change', {
+          target: {value: 'A'},
+        });
+        ctrl.find('InputText').at(1).find('input').simulate('change', {
+          target: {value: 'B'},
+        });
+        ctrl.find('InputText').at(1).find('input').simulate('keypress', {
+          key: 'Enter', shiftKey: true,
+        });
+        setTimeout(()=>{
+          expect(cmObj.getSearchCursor().replace).toHaveBeenCalled();
+          done();
+        }, 0);
+      });
+    });
+
   });
 });
diff --git a/web/regression/javascript/components/FormComponents.spec.js b/web/regression/javascript/components/FormComponents.spec.js
index 5bd6cdb28..dc180d42e 100644
--- a/web/regression/javascript/components/FormComponents.spec.js
+++ b/web/regression/javascript/components/FormComponents.spec.js
@@ -196,9 +196,7 @@ describe('FormComponents', ()=>{
     it('init', ()=>{
       expect(ctrl.find(InputLabel).text()).toBe('First');
       expect(ctrl.find(CodeMirror).prop('value')).toEqual('thevalue');
-      expect(ctrl.find(CodeMirror).prop('options')).toEqual(jasmine.objectContaining({
-        op1: 'test'
-      }));
+      expect(ctrl.find(CodeMirror).prop('op1')).toEqual('test');
       expect(ctrl.find(FormHelperText).text()).toBe('some help message');
     });
   });
diff --git a/web/regression/javascript/components/Menu.spec.js b/web/regression/javascript/components/Menu.spec.js
new file mode 100644
index 000000000..30e33b18d
--- /dev/null
+++ b/web/regression/javascript/components/Menu.spec.js
@@ -0,0 +1,158 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { withTheme } from '../fake_theme';
+import { createMount } from '@material-ui/core/test-utils';
+import { PgMenu, PgMenuItem } from '../../../pgadmin/static/js/components/Menu';
+
+describe('Menu', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+  });
+
+  const ThemedPgMenu = withTheme(PgMenu);
+  const eleRef = {
+    current: document.createElement('button'),
+  };
+
+  describe('PgMenu', ()=>{
+    const onClose = ()=>{/* on close call */};
+    let ctrl;
+    const ctrlMount = ()=>{
+      ctrl?.unmount();
+      ctrl = mount(
+        <ThemedPgMenu
+          anchorRef={eleRef}
+          onClose={onClose}
+          open={false}
+        />);
+    };
+    it('init', (done)=>{
+      ctrlMount();
+
+      setTimeout(()=>{
+        ctrl.update();
+        expect(ctrl.find('ForwardRef(ControlledMenu)')).toHaveProp('anchorRef', eleRef);
+        expect(ctrl.find('ForwardRef(ControlledMenu)')).toHaveProp('state', 'closed');
+        expect(ctrl.find('ForwardRef(ControlledMenu)')).toHaveProp('onClose', onClose);
+        done();
+      }, 0);
+    });
+
+    it('open', (done)=>{
+      ctrlMount();
+
+      setTimeout(()=>{
+        ctrl.update();
+        ctrl.setProps({open: true});
+        setTimeout(()=>{
+          expect(ctrl.find('ForwardRef(ControlledMenu)')).toHaveProp('state', 'open');
+          done();
+        }, 0);
+      }, 0);
+    });
+  });
+
+  describe('PgMenuItem', ()=>{
+    let ctrlMenu;
+    const ctrlMount = (props, callback)=>{
+      ctrlMenu?.unmount();
+      ctrlMenu = mount(
+        <ThemedPgMenu
+          anchorRef={eleRef}
+          open={false}
+        >
+          <PgMenuItem {...props}>Test</PgMenuItem>
+        </ThemedPgMenu>
+      );
+      ctrlMenu.setProps({open: true});
+      setTimeout(()=>{
+        ctrlMenu.update();
+        callback();
+      }, 0);
+    };
+
+    it('init', (done)=>{
+      ctrlMount({
+        shortcut: {
+          'control': true,
+          'shift': true,
+          'alt': false,
+          'key': {
+            'key_code': 75,
+            'char': 'k',
+          },
+        }
+      }, ()=>{
+        const menuItem = ctrlMenu.find('Memo(MenuItem)');
+        expect(menuItem.find('li[role="menuitem"]').text()).toBe('Test(Ctrl + Shift + K)');
+        done();
+      });
+    });
+
+    it('not checked', (done)=>{
+      ctrlMount({
+        hasCheck: true,
+      }, ()=>{
+        const checkIcon = ctrlMenu.find('ForwardRef(CheckIcon)');
+        expect(checkIcon.props()).toEqual(jasmine.objectContaining({
+          style: {
+            visibility: 'hidden',
+          }
+        }));
+        done();
+      });
+    });
+
+    it('checked', (done)=>{
+      ctrlMount({
+        hasCheck: true,
+        checked: true,
+      }, ()=>{
+        const checkIcon = ctrlMenu.find('ForwardRef(CheckIcon)');
+        expect(checkIcon.props()).toEqual(jasmine.objectContaining({
+          style: {},
+        }));
+        done();
+      });
+    });
+
+
+    it('checked clicked', (done)=>{
+      const onClick = jasmine.createSpy('onClick');
+      ctrlMount({
+        hasCheck: true,
+        checked: false,
+        onClick: onClick,
+      }, ()=>{
+        onClick.calls.reset();
+        ctrlMenu.find('Memo(MenuItem)').simulate('click');
+        expect(onClick.calls.mostRecent().args[0]).toEqual(jasmine.objectContaining({
+          keepOpen: true,
+        }));
+        done();
+      });
+    });
+  });
+});
diff --git a/web/regression/javascript/components/ShortcutTitle.spec.js b/web/regression/javascript/components/ShortcutTitle.spec.js
new file mode 100644
index 000000000..a88f9d7ad
--- /dev/null
+++ b/web/regression/javascript/components/ShortcutTitle.spec.js
@@ -0,0 +1,85 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { withTheme } from '../fake_theme';
+import { createMount } from '@material-ui/core/test-utils';
+import ShortcutTitle, { shortcutToString } from '../../../pgadmin/static/js/components/ShortcutTitle';
+import * as keyShort from '../../../pgadmin/static/js/keyboard_shortcuts';
+
+describe('ShortcutTitle', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+  });
+
+  const shortcut = {
+    'control': true,
+    'shift': true,
+    'alt': false,
+    'key': {
+      'key_code': 75,
+      'char': 'k',
+    },
+  };
+  it('ShortcutTitle', (done)=>{
+    let ThemedShortcutTitle = withTheme(ShortcutTitle);
+    spyOn(keyShort, 'isMac').and.returnValue(false);
+    let ctrl = mount(
+      <ThemedShortcutTitle
+        title="the title"
+        shortcut={shortcut}
+      />);
+    setTimeout(()=>{
+      ctrl.update();
+      expect(ctrl.text()).toBe('the titleCtrlShiftK');
+      done();
+    }, 0);
+  });
+
+  describe('shortcutToString', ()=>{
+
+    it('shortcut', ()=>{
+      spyOn(keyShort, 'isMac').and.returnValue(false);
+      expect(shortcutToString(shortcut)).toBe('Ctrl + Shift + K');
+    });
+
+    it('shortcut as array', ()=>{
+      spyOn(keyShort, 'isMac').and.returnValue(false);
+      expect(shortcutToString(shortcut, null, true)).toEqual(['Ctrl', 'Shift', 'K']);
+    });
+
+    it('accesskey', ()=>{
+      expect(shortcutToString(null, 'A')).toEqual('Accesskey + A');
+    });
+
+    it('both null', ()=>{
+      expect(shortcutToString(null, null)).toEqual('');
+    });
+
+    it('mac meta key', ()=>{
+      shortcut.ctrl_is_meta = true;
+      spyOn(keyShort, 'isMac').and.returnValue(true);
+      expect(shortcutToString(shortcut)).toBe('Cmd + Shift + K');
+    });
+  });
+});
diff --git a/web/regression/javascript/jasmine_capture_warnings_beforeall.js b/web/regression/javascript/jasmine_capture_warnings_beforeall.js
index 2eab2d9ac..310fb0330 100644
--- a/web/regression/javascript/jasmine_capture_warnings_beforeall.js
+++ b/web/regression/javascript/jasmine_capture_warnings_beforeall.js
@@ -10,15 +10,15 @@
 /* eslint-disable no-console */
 
 beforeAll(function () {
-  spyOn(console, 'warn').and.callThrough();
-  spyOn(console, 'error').and.callThrough();
+  // spyOn(console, 'warn').and.callThrough();
+  // spyOn(console, 'error').and.callThrough();
   jasmine.getEnv().allowRespy(true);
 });
 
 afterEach(function (done) {
   setTimeout(function () {
-    expect(console.warn).not.toHaveBeenCalled();
-    expect(console.error).not.toHaveBeenCalled();
+    // expect(console.warn).not.toHaveBeenCalled();
+    // expect(console.error).not.toHaveBeenCalled();
     done();
   }, 0);
 });
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 3181ecfe3..36c741c7a 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -77,7 +77,7 @@ const copyFiles = new CopyPlugin({
 });
 
 const imageMinimizer = new ImageMinimizerPlugin({
-  test: /\.(jpe?g|png|gif|svg)$/i,
+  test: /\.(jpe?g|png|gif)$/i,
   minimizerOptions: {
     // Lossless optimization with custom option
     // Feel free to experiment with options for better result for you
@@ -179,7 +179,24 @@ fs.writeFileSync(pgadminThemesJson, JSON.stringify(pgadminThemes, null, 4));
 
 var themeCssRules = function(theme_name) {
   return [{
-    test: /\.(jpe?g|png|gif|svg)$/i,
+    test: /\.svg$/,
+    oneOf: [
+      {
+        issuer: /\.[jt]sx?$/,
+        resourceQuery: /svgr/,
+        use: ['@svgr/webpack'],
+      },
+      {
+        type: 'asset',
+        parser: {
+          dataUrlCondition: {
+            maxSize: 4 * 1024, // 4kb
+          }
+        }
+      },
+    ],
+  },{
+    test: /\.(jpe?g|png|gif)$/i,
     type: 'asset',
     parser: {
       dataUrlCondition: {
@@ -191,7 +208,7 @@ var themeCssRules = function(theme_name) {
     },
     exclude: /vendor/,
   },{
-    test: /\.(eot|svg|ttf|woff|woff2)$/,
+    test: /\.(eot|ttf|woff|woff2)$/,
     type: 'asset/resource',
     generator: {
       filename: 'fonts/[name].[ext]',
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 0430047c0..92021f108 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -143,7 +143,8 @@ var webpackShimConfig = {
     'dropzone': path.join(__dirname, './node_modules/dropzone/dist/dropzone'),
     'bignumber': path.join(__dirname, './node_modules/bignumber.js/bignumber'),
     'json-bignumber': path.join(__dirname, './node_modules/json-bignumber/dist/JSONBigNumber.min'),
-    'jsoneditor': path.join(__dirname, './node_modules/jsoneditor/dist/jsoneditor.min'),
+    'jsoneditor.min': path.join(__dirname, './node_modules/jsoneditor/dist/jsoneditor.min'),
+    'jsoneditor': path.join(__dirname, './node_modules/jsoneditor'),
     'snap.svg': path.join(__dirname, './node_modules/snapsvg-cjs/dist/snap.svg-cjs'),
     'color-picker': path.join(__dirname, './node_modules/@simonwep/pickr/dist/pickr.es5.min'),
     'mousetrap': path.join(__dirname, './node_modules/mousetrap'),
@@ -303,6 +304,7 @@ var webpackShimConfig = {
     'pgadmin.tools.erd': path.join(__dirname, './pgadmin/tools/erd/static/js'),
     'pgadmin.tools.psql_module': path.join(__dirname, './pgadmin/tools/psql/static/js/psql_module'),
     'pgadmin.tools.psql': path.join(__dirname, './pgadmin/tools/psql/static/js'),
+    'pgadmin.tools.query_tool': path.join(__dirname, './pgadmin/tools/query_tool/static/js'),
     'pgadmin.search_objects': path.join(__dirname, './pgadmin/tools/search_objects/static/js'),
     'pgadmin.tools.user_management': path.join(__dirname, './pgadmin/tools/user_management/static/js/user_management'),
     'pgadmin.user_management.current_user': '/user_management/current_user',
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index 1e13ff57c..c36d463b9 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -30,7 +30,7 @@ module.exports = {
       Buffer: ['buffer', 'Buffer'],
     }),
     new ImageMinimizerPlugin({
-      test: /\.(jpe?g|png|gif|svg)$/i,
+      test: /\.(jpe?g|png|gif)$/i,
       minimizerOptions: {
         // Lossless optimization with custom option
         // Feel free to experiment with options for better result for you
@@ -71,7 +71,24 @@ module.exports = {
       type: 'asset/source',
       use: ['style-loader'],
     }, {
-      test: /\.(jpe?g|png|gif|svg)$/i,
+      test: /\.svg$/,
+      oneOf: [
+        {
+          issuer: /\.[jt]sx?$/,
+          resourceQuery: /svgr/,
+          use: ['@svgr/webpack'],
+        },
+        {
+          type: 'asset',
+          parser: {
+            dataUrlCondition: {
+              maxSize: 4 * 1024, // 4kb
+            }
+          }
+        },
+      ],
+    }, {
+      test: /\.(jpe?g|png|gif)$/i,
       type: 'asset',
       parser: {
         dataUrlCondition: {
